<!DOCTYPE html>
<html>

<head>

<meta charset="UTF-8">
<meta name=viewport content="width=device-width, initial-scale=1">


<title>Why Drill - Apache Drill</title>

<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css" rel="stylesheet" type="text/css"/>
<link href='//fonts.googleapis.com/css?family=PT+Sans' rel='stylesheet' type='text/css'/>
<link href="/css/site.css" rel="stylesheet" type="text/css"/>

<link rel="shortcut icon" href="/favicon.ico" type="image/x-icon"/>
<link rel="icon" href="/favicon.ico" type="image/x-icon"/>

<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js" language="javascript" type="text/javascript"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.3/jquery.easing.min.js" language="javascript" type="text/javascript"></script>
<script language="javascript" type="text/javascript" src="/js/modernizr.custom.js"></script>
<script language="javascript" type="text/javascript" src="/js/script.js"></script>
<script language="javascript" type="text/javascript" src="/js/drill.js"></script>

</head>


<body onResize="resized();">
  <div class="page-wrap">
    <div class="bui"></div>

<div id="menu" class="mw">
<ul>
  <li class='toc-categories'>
  <a class="expand-toc-icon" href="javascript:void(0);"><i class="fa fa-bars"></i></a>
  </li>
  <li class="logo"><a href="/"></a></li>
  <li class='expand-menu'>
  <a href="javascript:void(0);"><span class='menu-text'>Menu</span><span class='expand-icon'><i class="fa fa-bars"></i></span></a>
  </li>
  <li class='clear-float'></li>
  <li class="documentation-menu">
    <a href="/docs/">Documentation</a>
    <ul>
      
        <li><a href="/docs/getting-started/">Getting Started</a></li>
      
        <li><a href="/docs/architecture/">Architecture</a></li>
      
        <li><a href="/docs/tutorials/">Tutorials</a></li>
      
        <li><a href="/docs/install-drill/">Install Drill</a></li>
      
        <li><a href="/docs/configure-drill/">Configure Drill</a></li>
      
        <li><a href="/docs/connect-a-data-source/">Connect a Data Source</a></li>
      
        <li><a href="/docs/odbc-jdbc-interfaces/">ODBC/JDBC Interfaces</a></li>
      
        <li><a href="/docs/query-data/">Query Data</a></li>
      
        <li><a href="/docs/performance-tuning/">Performance Tuning</a></li>
      
        <li><a href="/docs/log-and-debug/">Log and Debug</a></li>
      
        <li><a href="/docs/sql-reference/">SQL Reference</a></li>
      
        <li><a href="/docs/data-sources-and-file-formats/">Data Sources and File Formats</a></li>
      
        <li><a href="/docs/develop-custom-functions/">Develop Custom Functions</a></li>
      
        <li><a href="/docs/troubleshooting/">Troubleshooting</a></li>
      
        <li><a href="/docs/developer-information/">Developer Information</a></li>
      
        <li><a href="/docs/release-notes/">Release Notes</a></li>
      
        <li><a href="/docs/sample-datasets/">Sample Datasets</a></li>
      
        <li><a href="/docs/archived-pages/">Archived Pages</a></li>
      
        <li><a href="/docs/progress-reports/">Progress Reports</a></li>
      
        <li><a href="/docs/project-bylaws/">Project Bylaws</a></li>
      
    </ul>
  </li>
  <li class='nav'>
    <a href="/community-resources/">Community</a>
    <ul>
      <li><a href="/team/">Team</a></li>
      <li><a href="/mailinglists/">Mailing Lists</a></li>
      <li><a href="/community-resources/">Community Resources</a></li>
    </ul>
  </li>
  <li class='nav'><a href="/faq/">FAQ</a></li>
  <li class='nav'><a href="/blog/">Blog</a></li>
  <li id="twitter-menu-item"><a href="https://twitter.com/apachedrill" title="apachedrill on twitter" target="_blank"><img src="/images/twitter_32_26_white.png" alt="twitter logo" align="center"></a> </li>
  <li class='search-bar'>
    <form id="drill-search-form">
      <input type="text" placeholder="Search Apache Drill" id="drill-search-term" />
      <button type="submit">
        <i class="fa fa-search"></i>
      </button>
    </form>
  </li>
  <li class="d">
    <a href="/download/">
      <i class="fa fa-cloud-download"></i> Download
    </a>
  </li>
</ul>
</div>

    <div class="int_title">
<h1>Why Drill</h1>
  <p>Top 10 Reasons to Use Drill</p>
</div>

<div class="int_text" align="left"><h2>1. Get started in minutes</h2>
<p>It only takes a couple minutes to start working with Drill. Untar it on your Mac or Windows laptop and run a query on a local file. No need to set up any infrastructure. No need to define schemas. Just point at the data and drill!</p>
<div class="highlight"><pre><code class="language-bash" data-lang="bash"><span class="nv">$ </span>tar -xvf apache-drill-0.6.0-incubating.tar.gz
<span class="nv">$ </span>apache-drill-0.6.0-incubating/bin/sqlline -u jdbc:drill:zk<span class="o">=</span><span class="nb">local</span>
0: jdbc:drill:zk<span class="o">=</span><span class="nb">local</span>&gt; SELECT * FROM dfs.root.<span class="sb">`</span>path/to/employee.json<span class="sb">`</span> limit 5<span class="p">;</span>
+-------------+------------------+------------+------------+-------------+----------------------+------------+---------------+-----
<span class="p">|</span> employee_id <span class="p">|</span> full_name        <span class="p">|</span> first_name <span class="p">|</span> last_name  <span class="p">|</span> position_id <span class="p">|</span> position_title       <span class="p">|</span>  store_id  <span class="p">|</span> department_id <span class="p">|</span> birt 
+-------------+------------------+------------+------------+-------------+----------------------+------------+---------------+------+
<span class="p">|</span> <span class="m">1</span>           <span class="p">|</span> Sheri Nowmer     <span class="p">|</span> Sheri      <span class="p">|</span> Nowmer     <span class="p">|</span> <span class="m">1</span>           <span class="p">|</span> President            <span class="p">|</span> <span class="m">0</span>          <span class="p">|</span> <span class="m">1</span>             <span class="p">|</span> <span class="m">19</span>   
<span class="p">|</span> <span class="m">2</span>           <span class="p">|</span> Derrick Whelply  <span class="p">|</span> Derrick    <span class="p">|</span> Whelply    <span class="p">|</span> <span class="m">2</span>           <span class="p">|</span> VP Country Manager   <span class="p">|</span> <span class="m">0</span>          <span class="p">|</span> <span class="m">1</span>             <span class="p">|</span>
<span class="p">|</span> <span class="m">4</span>           <span class="p">|</span> Michael Spence   <span class="p">|</span> Michael    <span class="p">|</span> Spence     <span class="p">|</span> <span class="m">2</span>           <span class="p">|</span> VP Country Manager   <span class="p">|</span> <span class="m">0</span>          <span class="p">|</span> <span class="m">1</span>             <span class="p">|</span>
<span class="p">|</span> <span class="m">5</span>           <span class="p">|</span> Maya Gutierrez   <span class="p">|</span> Maya       <span class="p">|</span> Gutierrez  <span class="p">|</span> <span class="m">2</span>           <span class="p">|</span> VP Country Manager   <span class="p">|</span> <span class="m">0</span>          <span class="p">|</span> <span class="m">1</span>             <span class="p">|</span>
<span class="p">|</span> <span class="m">6</span>           <span class="p">|</span> Roberta Damstra  <span class="p">|</span> Roberta    <span class="p">|</span> Damstra    <span class="p">|</span> <span class="m">3</span>           <span class="p">|</span> VP Information Systems <span class="p">|</span> <span class="m">0</span>        <span class="p">|</span> <span class="m">2</span>             <span class="p">|</span>
+-------------+------------------+------------+------------+-------------+----------------------+------------+---------------+-----</code></pre></div>
<h2>2. Schema-free JSON model</h2>
<p>Drill is the world's first and only distributed SQL engine that doesn't require schemas. It shares the same schema-free JSON model as MongoDB and Elasticsearch. Instead of spending weeks or months defining schemas, transforming data (ETL) and maintaining those schemas, simply point Drill at your data (file, directory, HBase table, etc.) and run your queries. Drill automatically understands the structure of the data. Drill's self-service approach reduces the burden on IT and increases the productivity and agility of analysts and developers.</p>

<h2>3. Query complex, semi-structured data in-situ</h2><p>Drill's schema-free JSON model allows you to query complex, semi-structured data in situ. No need to flatten or transform the data prior to or during query execution. Drill also provides intuitive extensions to SQL to work with nested data. Here's a simple query on a JSON file demonstrating how to access nested elements and arrays:</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="k">SELECT</span> <span class="o">*</span> <span class="k">FROM</span> <span class="p">(</span><span class="k">SELECT</span> <span class="n">t</span><span class="p">.</span><span class="n">trans_id</span><span class="p">,</span>
                      <span class="n">t</span><span class="p">.</span><span class="n">trans_info</span><span class="p">.</span><span class="n">prod_id</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="k">AS</span> <span class="n">prod_id</span><span class="p">,</span>
                      <span class="n">t</span><span class="p">.</span><span class="n">trans_info</span><span class="p">.</span><span class="n">purch_flag</span> <span class="k">AS</span> <span class="n">purchased</span>
               <span class="k">FROM</span> <span class="o">`</span><span class="n">clicks</span><span class="o">/</span><span class="n">clicks</span><span class="p">.</span><span class="n">json</span><span class="o">`</span> <span class="n">t</span><span class="p">)</span> <span class="n">sq</span>
<span class="k">WHERE</span> <span class="n">sq</span><span class="p">.</span><span class="n">prod_id</span> <span class="k">BETWEEN</span> <span class="mi">700</span> <span class="k">AND</span> <span class="mi">750</span> <span class="k">AND</span>
      <span class="n">sq</span><span class="p">.</span><span class="n">purchased</span> <span class="o">=</span> <span class="s1">&#39;true&#39;</span>
<span class="k">ORDER</span> <span class="k">BY</span> <span class="n">sq</span><span class="p">.</span><span class="n">prod_id</span><span class="p">;</span></code></pre></div>

<h2>4. Real SQL - not "SQL-like"</h2>
<p>Drill supports the standard SQL:2003 syntax. No need to learn a new "SQL-like" language or struggle with a semi-functional BI tool. Drill supports many data types including DATE, INTERVAL, TIMESTAMP, VARCHAR and DECIMAL, as well as complex query constructs such as correlated sub-queries and joins in WHERE clauses. Here is an example of a TPC-H standard query that runs in Drill "as is":</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="o">#</span> <span class="n">TPC</span><span class="o">-</span><span class="n">H</span> <span class="n">query</span> <span class="mi">4</span>
<span class="k">SELECT</span>  <span class="n">o</span><span class="p">.</span><span class="n">o_orderpriority</span><span class="p">,</span> <span class="k">count</span><span class="p">(</span><span class="o">*</span><span class="p">)</span> <span class="k">AS</span> <span class="n">order_count</span>
<span class="k">FROM</span> <span class="n">orders</span> <span class="n">o</span>
<span class="k">WHERE</span> <span class="n">o</span><span class="p">.</span><span class="n">o_orderdate</span> <span class="o">&gt;=</span> <span class="nb">date</span> <span class="s1">&#39;1996-10-01&#39;</span>
      <span class="k">AND</span> <span class="n">o</span><span class="p">.</span><span class="n">o_orderdate</span> <span class="o">&lt;</span> <span class="nb">date</span> <span class="s1">&#39;1996-10-01&#39;</span> <span class="o">+</span> <span class="nb">interval</span> <span class="s1">&#39;3&#39;</span> <span class="k">month</span>
      <span class="k">AND</span> <span class="k">EXISTS</span><span class="p">(</span>
                 <span class="k">SELECT</span> <span class="o">*</span> <span class="k">FROM</span> <span class="n">lineitem</span> <span class="n">l</span> 
                 <span class="k">WHERE</span> <span class="n">l</span><span class="p">.</span><span class="n">l_orderkey</span> <span class="o">=</span> <span class="n">o</span><span class="p">.</span><span class="n">o_orderkey</span>
                 <span class="k">AND</span> <span class="n">l</span><span class="p">.</span><span class="n">l_commitdate</span> <span class="o">&lt;</span> <span class="n">l</span><span class="p">.</span><span class="n">l_receiptdate</span>
                 <span class="p">)</span>
      <span class="k">GROUP</span> <span class="k">BY</span> <span class="n">o</span><span class="p">.</span><span class="n">o_orderpriority</span>
      <span class="k">ORDER</span> <span class="k">BY</span> <span class="n">o</span><span class="p">.</span><span class="n">o_orderpriority</span><span class="p">;</span></code></pre></div>

<h2>5. Leverage standard BI tools</h2>
<p>Drill works with standard BI tools. You can keep using the tools you love, such as Tableau, MicroStrategy, QlikView and Excel. No need to introduce yet another visualization or dashboard tool. Combine a self-service BI tool with the only self-service SQL engine to enable true self-service data exploration.</p>

<h2>6. Interactive queries on Hive tables</h2><p>Apache Drill lets you leverage your investments in Hive. You can run interactive queries with Drill on your Hive tables and access all Hive input/output formats (including custom SerDes). You can join tables associated with different Hive metastores, and you can join a Hive table with an HBase table or a directory of log files. Here's a simple query in Drill on a Hive table:</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="k">SELECT</span> <span class="o">`</span><span class="k">month</span><span class="o">`</span><span class="p">,</span> <span class="k">state</span><span class="p">,</span> <span class="k">sum</span><span class="p">(</span><span class="n">order_total</span><span class="p">)</span> <span class="k">AS</span> <span class="n">sales</span>
<span class="k">FROM</span> <span class="n">hive</span><span class="p">.</span><span class="n">orders</span> 
<span class="k">GROUP</span> <span class="k">BY</span> <span class="o">`</span><span class="k">month</span><span class="o">`</span><span class="p">,</span> <span class="k">state</span>
<span class="k">ORDER</span> <span class="k">BY</span> <span class="mi">3</span> <span class="k">DESC</span> <span class="k">LIMIT</span> <span class="mi">5</span><span class="p">;</span></code></pre></div>

<h2>7. Access multiple data sources</h2><p>Drill is designed with extensibility in mind. It provides out-of-the-box connectivity to file systems (local or distributed file systems such as S3, HDFS and MapR-FS), HBase and Hive. You can implement a storage plugin to make Drill work with any other data source. Drill can combine data from multiple data sources on the fly in a single query, with no centralized metadata definitions. Here's a query that combines data from a Hive table, an HBase table (view) and a JSON file:</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="k">SELECT</span> <span class="n">custview</span><span class="p">.</span><span class="n">membership</span><span class="p">,</span> <span class="k">sum</span><span class="p">(</span><span class="n">orders</span><span class="p">.</span><span class="n">order_total</span><span class="p">)</span> <span class="k">AS</span> <span class="n">sales</span>
<span class="k">FROM</span> <span class="n">hive</span><span class="p">.</span><span class="n">orders</span><span class="p">,</span> <span class="n">custview</span><span class="p">,</span> <span class="n">dfs</span><span class="p">.</span><span class="o">`</span><span class="n">clicks</span><span class="o">/</span><span class="n">clicks</span><span class="p">.</span><span class="n">json</span><span class="o">`</span> <span class="k">c</span> 
<span class="k">WHERE</span> <span class="n">orders</span><span class="p">.</span><span class="n">cust_id</span> <span class="o">=</span> <span class="n">custview</span><span class="p">.</span><span class="n">cust_id</span> <span class="k">AND</span> <span class="n">orders</span><span class="p">.</span><span class="n">cust_id</span> <span class="o">=</span> <span class="k">c</span><span class="p">.</span><span class="n">user_info</span><span class="p">.</span><span class="n">cust_id</span> 
<span class="k">GROUP</span> <span class="k">BY</span> <span class="n">custview</span><span class="p">.</span><span class="n">membership</span>
<span class="k">ORDER</span> <span class="k">BY</span> <span class="mi">2</span><span class="p">;</span></code></pre></div>

<h2>8. User-Defined Functions (UDFs)</h2><p>Drill exposes a simple and high-performance Java API to build custom functions (UDFs and UDAFs) so that you can add your own business logic. If you have already built UDFs in Hive, you can reuse them with Drill with no modifications. Refer to <a href="https://cwiki.apache.org/confluence/display/DRILL/Develop+Custom+Functions">Developing Custom Functions</a> for more information.
</p>

<h2>9. High performance</h2><p>Drill is designed fround the ground up for high throughput and low latency. It doesn't use a general purpose execution engine like MapReduce, Tez or Spark. As a result, Drill is able to deliver its unparalleled flexibility (schema-free JSON model) without compromising performance. Drill's optimizer leverages rule- and cost-based techniques, as well as data locality and operator push-down (the ability to push down query fragments into the back-end data sources). Drill also provides a columnar and vectorized execution engine, resulting in higher memory and CPU efficiency.</p>

<h2>10. Scales from a single laptop to a 1000-node cluster</h2><p>Drill is available as a simple download you can run on your laptop. When you're ready to analyze larger datasets, simply deploy Drill on your Hadoop cluster (up to 1000 commodity servers). Drill leverages the aggregate memory in the cluster to execute queries using an optimistic pipelined model, and automatically spills to disk when the working set doesn't fit in memory.</p>
</div>

  </div>
  <p class="push"></p>
<div id="footer" class="mw">
<div class="wrapper">
Copyright © 2012-2014 The Apache Software Foundation, licensed under the Apache License, Version 2.0.<br>
Apache and the Apache feather logo are trademarks of The Apache Software Foundation. Other names appearing on the site may be trademarks of their respective owners.<br/><br/>
</div>
</div>

  <script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
})(window,document,'script','//www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-53379651-1', 'auto');
ga('send', 'pageview');
</script>

</body>
</html>
